import sys
import string
import os

def modifyWord(prevw, wrd):
    wrd = filterNonChar(wrd)
    if wrd == "": return ""
    if wrd[0] == "=": return wrd
    if prevw[-1] == "=": return wrd
    casTypN = getWCaseType(wrd)
    if casTypN == "Ponct": return wrd
    wrd = reduceWord(wrd)
    casTypP = getWCaseType(prevw)
    if casTypP == "Mix": return "_" + wrd
    if casTypN == "Mix": return "_" + wrd
    if (casTypP == "AllLow") and (casTypN == "AllLow"): return "_" + wrd
    if (casTypP == "AllCap") and (casTypN == "AllCap"): return "_" + wrd
    if (casTypP == "AllCap") and (casTypN == "Cap1st"): return "_" + wrd
    if (casTypP == "Cap1st") and (casTypN == "AllLow"): return "_" + wrd
    #return "_" + wrd
    return wrd

def getWCaseType(wrd):
    CapFirst = 0
    NxAllLow = 1
    NxAllCap = 1
    if not wrd[0] in string.letters:
        if not wrd[0] in string.digits: return "Ponct"
    if wrd[0] in string.uppercase: CapFirst = 1
    for wr in wrd[1:]:
      if wr in string.lowercase: NxAllCap = 0
      if wr in string.uppercase: NxAllLow = 0
    if CapFirst:
        if NxAllCap: return "AllCap"
        elif NxAllLow: return "Cap1st"
        else: return "Mix"
    else:
        if NxAllLow: return "AllLow"
        else: return "Mix"

def filterNonChar(wrd):
    chrToRem = "$%',?!><\/*{}()[]_-"
    chrToReplace ="|:"
    # all others to keep as is
    newwrd = ""
    for ww in wrd:
        if ww in chrToRem: continue
        elif ww in chrToReplace: newwrd = newwrd + "="
        else: newwrd = newwrd + ww
    return newwrd


def reduceWord(wrd):
    lwrd = string.lower(wrd)
    if lwrd == "application": return "App"
    if lwrd == "applications": return "Apps"
    if lwrd == "manager": return "Mgr"
    if lwrd == "management": return "Managm"
    #if lwrd == "software": return "sw"
    if lwrd == "certification": return "Cert"
    if lwrd == "database": return "db"
    if lwrd == "databases": return "dbs"
    if lwrd == "organization": return "Org"
    if lwrd == "technology": return "Tech"
    return wrd



#---------------------------TEST
#print getWCaseType(sys.argv[1])
#mystr = sys.argv[1]
#print mystr + sys.argv[2]
#sys.exit(0)
# --------------------------
opt = "-N";
if len(sys.argv) > 3:
    opt = sys.argv[3]

if len(sys.argv) < 3:
    sys.exit(11)

mydir = sys.argv[1]
mystr = sys.argv[2]
if(not os.path.isdir(mydir)):
    #print "Dir not exist: " + destDir
    sys.exit(12)

mystr = string.strip(mystr)
#print mystr
#sys.exit(0)
print "OPT= " + opt
if opt == "-C":
    mywrd = string.capwords(mystr)
    mywrd = string.replace(mywrd, " ", "")
    mywrd = string.replace(mywrd, "\t", "")
    mywrd = string.replace(mywrd, "\n", "")
    mywrd = string.replace(mywrd, "\r", "")
elif opt == "-U":
    mywrd = string.replace(mystr, " ", "_")
    mywrd = string.replace(mywrd, "\t", "_")
    mywrd = string.replace(mywrd, "\n", "_")
    mywrd = string.replace(mywrd, "\r", "_")
elif opt == "-F":
    pos = string.rfind(mystr, "/")
    if pos < 0: mywrd = mystr
    else:
        mywrd = mystr[pos + 1:]
        pos = string.rfind(mywrd, ".")
        if pos > 0:
            mywrd = mywrd[:pos]
elif opt == "-H":
    pos = string.find(mystr, "http://")
    if pos < 0: mywrd = mystr
    else:
        mywrd = mystr[pos + 7:]
        pos = string.find(mywrd, "/")
        if pos > 0:
            mywrd = mywrd[:pos]
    #print mywrd
    #sys.exit(0)
elif opt == "-N":
    mywlst = string.split(mystr, " ")
    #print mywlst
    #sys.exit(0)
    mywrd = ""      #Filename to construct
    cnt = 0;
    prevwrd = "";
    for itm in mywlst:
        if cnt == 0:
            mywrd = mywrd + string.capitalize(itm[0]) + itm[1:]
        else:
            mywrd = mywrd + modifyWord(prevwrd, itm)
        cnt = cnt + 1
        prevwrd = itm;
else:
    sys.exit(13)

if len(sys.argv) > 4:
    myext = sys.argv[4]
    print mywrd + myext
else:
    pat = mydir + os.sep + mywrd
    try:
        os.mkdir(pat)
        #print pat
    except:
        sys.exit(14)
sys.exit(0)
# --------------------------


mystr = mystr + ".htm"
print mystr
